<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>Mu - linux/tile/float-stack.mu</title>
<meta name="Generator" content="Vim/8.2">
<meta name="plugin-version" content="vim8.1_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,pre_wrap,no_foldcolumn,expand_tabs,line_ids,prevent_copy=,use_input_for_pc=fallback">
<meta name="colorscheme" content="minimal-light">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #000000; background-color: #ffffd7; }
body { font-size:12pt; font-family: monospace; color: #000000; background-color: #ffffd7; }
a { color:inherit; }
* { font-size:12pt; font-size: 1em; }
.PreProc { color: #c000c0; }
.muRegEdx { color: #af5f00; }
.LineNr { }
.Constant { color: #008787; }
.muRegEsi { color: #005faf; }
.muRegEdi { color: #00af00; }
.muRegEcx { color: #870000; }
.Delimiter { color: #c000c0; }
.muFunction { color: #af5f00; text-decoration: underline; }
.Special { color: #ff6060; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<a href='https://github.com/akkartik/mu/blob/main/linux/tile/float-stack.mu'>https://github.com/akkartik/mu/blob/main/linux/tile/float-stack.mu</a>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr"> 1 </span><span class="PreProc">type</span> <a href='float-stack.mu.html#L1'>float-stack</a> <span class="Delimiter">{</span>
<span id="L2" class="LineNr"> 2 </span>  data: (handle array float)
<span id="L3" class="LineNr"> 3 </span>  <a href='../203stack.subx.html#L338'>top</a>: int
<span id="L4" class="LineNr"> 4 </span><span class="Delimiter">}</span>
<span id="L5" class="LineNr"> 5 </span>
<span id="L6" class="LineNr"> 6 </span><span class="PreProc">fn</span> <span class="muFunction"><a href='float-stack.mu.html#L6'>initialize-float-stack</a></span> _self: (addr <a href='float-stack.mu.html#L1'>float-stack</a>), n: int <span class="Delimiter">{</span>
<span id="L7" class="LineNr"> 7 </span>  <span class="PreProc">var</span> self/<span class="muRegEsi">esi</span>: (addr <a href='float-stack.mu.html#L1'>float-stack</a>) <span class="Special">&lt;-</span> copy _self
<span id="L8" class="LineNr"> 8 </span>  <span class="PreProc">var</span> d/<span class="muRegEdi">edi</span>: (addr handle array float) <span class="Special">&lt;-</span> <a href='../131table.subx.html#L26'>get</a> self, data
<span id="L9" class="LineNr"> 9 </span>  populate d, n
<span id="L10" class="LineNr">10 </span>  <span class="PreProc">var</span> <a href='../203stack.subx.html#L338'>top</a>/eax: (addr int) <span class="Special">&lt;-</span> <a href='../131table.subx.html#L26'>get</a> self, <a href='../203stack.subx.html#L338'>top</a>
<span id="L11" class="LineNr">11 </span>  copy-to *top, <span class="Constant">0</span>
<span id="L12" class="LineNr">12 </span><span class="Delimiter">}</span>
<span id="L13" class="LineNr">13 </span>
<span id="L14" class="LineNr">14 </span><span class="PreProc">fn</span> <span class="muFunction"><a href='float-stack.mu.html#L14'>clear-float-stack</a></span> _self: (addr <a href='float-stack.mu.html#L1'>float-stack</a>) <span class="Delimiter">{</span>
<span id="L15" class="LineNr">15 </span>  <span class="PreProc">var</span> self/<span class="muRegEsi">esi</span>: (addr <a href='float-stack.mu.html#L1'>float-stack</a>) <span class="Special">&lt;-</span> copy _self
<span id="L16" class="LineNr">16 </span>  <span class="PreProc">var</span> <a href='../203stack.subx.html#L338'>top</a>/eax: (addr int) <span class="Special">&lt;-</span> <a href='../131table.subx.html#L26'>get</a> self, <a href='../203stack.subx.html#L338'>top</a>
<span id="L17" class="LineNr">17 </span>  copy-to *top, <span class="Constant">0</span>
<span id="L18" class="LineNr">18 </span><span class="Delimiter">}</span>
<span id="L19" class="LineNr">19 </span>
<span id="L20" class="LineNr">20 </span><span class="PreProc">fn</span> <span class="muFunction"><a href='float-stack.mu.html#L20'>push-float-stack</a></span> _self: (addr <a href='float-stack.mu.html#L1'>float-stack</a>), _val: float <span class="Delimiter">{</span>
<span id="L21" class="LineNr">21 </span>  <span class="PreProc">var</span> self/<span class="muRegEsi">esi</span>: (addr <a href='float-stack.mu.html#L1'>float-stack</a>) <span class="Special">&lt;-</span> copy _self
<span id="L22" class="LineNr">22 </span>  <span class="PreProc">var</span> top-addr/<span class="muRegEcx">ecx</span>: (addr int) <span class="Special">&lt;-</span> <a href='../131table.subx.html#L26'>get</a> self, <a href='../203stack.subx.html#L338'>top</a>
<span id="L23" class="LineNr">23 </span>  <span class="PreProc">var</span> data-ah/<span class="muRegEdx">edx</span>: (addr handle array float) <span class="Special">&lt;-</span> <a href='../131table.subx.html#L26'>get</a> self, data
<span id="L24" class="LineNr">24 </span>  <span class="PreProc">var</span> data/eax: (addr array float) <span class="Special">&lt;-</span> <a href='../120allocate.subx.html#L258'>lookup</a> *data-ah
<span id="L25" class="LineNr">25 </span>  <span class="PreProc">var</span> <a href='../203stack.subx.html#L338'>top</a>/<span class="muRegEdx">edx</span>: int <span class="Special">&lt;-</span> copy *top-addr
<span id="L26" class="LineNr">26 </span>  <span class="PreProc">var</span> dest-addr/<span class="muRegEdx">edx</span>: (addr float) <span class="Special">&lt;-</span> index data, <a href='../203stack.subx.html#L338'>top</a>
<span id="L27" class="LineNr">27 </span>  <span class="PreProc">var</span> val/<span class="Constant">xmm0</span>: float <span class="Special">&lt;-</span> copy _val
<span id="L28" class="LineNr">28 </span>  copy-to *dest-addr, val
<span id="L29" class="LineNr">29 </span>  add-to *top-addr, <span class="Constant">1</span>
<span id="L30" class="LineNr">30 </span><span class="Delimiter">}</span>
<span id="L31" class="LineNr">31 </span>
<span id="L32" class="LineNr">32 </span><span class="PreProc">fn</span> <span class="muFunction"><a href='float-stack.mu.html#L32'>pop-float-stack</a></span> _self: (addr <a href='float-stack.mu.html#L1'>float-stack</a>)<span class="PreProc"> -&gt; </span>_/<span class="Constant">xmm0</span>: float <span class="Delimiter">{</span>
<span id="L33" class="LineNr">33 </span>  <span class="PreProc">var</span> self/<span class="muRegEsi">esi</span>: (addr <a href='float-stack.mu.html#L1'>float-stack</a>) <span class="Special">&lt;-</span> copy _self
<span id="L34" class="LineNr">34 </span>  <span class="PreProc">var</span> top-addr/<span class="muRegEcx">ecx</span>: (addr int) <span class="Special">&lt;-</span> <a href='../131table.subx.html#L26'>get</a> self, <a href='../203stack.subx.html#L338'>top</a>
<span id="L35" class="LineNr">35 </span>  <span class="Delimiter">{</span>
<span id="L36" class="LineNr">36 </span>    compare *top-addr, <span class="Constant">0</span>
<span id="L37" class="LineNr">37 </span>    <span class="PreProc">break-if-&gt;</span>
<span id="L38" class="LineNr">38 </span>    <span class="PreProc">var</span> zero: float
<span id="L39" class="LineNr">39 </span>    <span class="PreProc">return</span> zero
<span id="L40" class="LineNr">40 </span>  <span class="Delimiter">}</span>
<span id="L41" class="LineNr">41 </span>  subtract-from *top-addr, <span class="Constant">1</span>
<span id="L42" class="LineNr">42 </span>  <span class="PreProc">var</span> data-ah/<span class="muRegEdx">edx</span>: (addr handle array float) <span class="Special">&lt;-</span> <a href='../131table.subx.html#L26'>get</a> self, data
<span id="L43" class="LineNr">43 </span>  <span class="PreProc">var</span> data/eax: (addr array float) <span class="Special">&lt;-</span> <a href='../120allocate.subx.html#L258'>lookup</a> *data-ah
<span id="L44" class="LineNr">44 </span>  <span class="PreProc">var</span> <a href='../203stack.subx.html#L338'>top</a>/<span class="muRegEdx">edx</span>: int <span class="Special">&lt;-</span> copy *top-addr
<span id="L45" class="LineNr">45 </span>  <span class="PreProc">var</span> result-addr/eax: (addr float) <span class="Special">&lt;-</span> index data, <a href='../203stack.subx.html#L338'>top</a>
<span id="L46" class="LineNr">46 </span>  <span class="PreProc">return</span> *result-addr
<span id="L47" class="LineNr">47 </span><span class="Delimiter">}</span>
<span id="L48" class="LineNr">48 </span>
<span id="L49" class="LineNr">49 </span><span class="PreProc">fn</span> <span class="muFunction"><a href='float-stack.mu.html#L49'>float-stack-empty?</a></span> _self: (addr <a href='float-stack.mu.html#L1'>float-stack</a>)<span class="PreProc"> -&gt; </span>_/eax: boolean <span class="Delimiter">{</span>
<span id="L50" class="LineNr">50 </span>  <span class="PreProc">var</span> self/<span class="muRegEsi">esi</span>: (addr <a href='float-stack.mu.html#L1'>float-stack</a>) <span class="Special">&lt;-</span> copy _self
<span id="L51" class="LineNr">51 </span>  <span class="PreProc">var</span> top-addr/eax: (addr int) <span class="Special">&lt;-</span> <a href='../131table.subx.html#L26'>get</a> self, <a href='../203stack.subx.html#L338'>top</a>
<span id="L52" class="LineNr">52 </span>  compare *top-addr, <span class="Constant">0</span>
<span id="L53" class="LineNr">53 </span>  <span class="Delimiter">{</span>
<span id="L54" class="LineNr">54 </span>    <span class="PreProc">break-if-!=</span>
<span id="L55" class="LineNr">55 </span>    <span class="PreProc">return</span> <span class="Constant">1</span>/true
<span id="L56" class="LineNr">56 </span>  <span class="Delimiter">}</span>
<span id="L57" class="LineNr">57 </span>  <span class="PreProc">return</span> <span class="Constant">0</span>/false
<span id="L58" class="LineNr">58 </span><span class="Delimiter">}</span>
<span id="L59" class="LineNr">59 </span>
<span id="L60" class="LineNr">60 </span><span class="PreProc">fn</span> <span class="muFunction"><a href='float-stack.mu.html#L60'>float-stack-length</a></span> _self: (addr <a href='float-stack.mu.html#L1'>float-stack</a>)<span class="PreProc"> -&gt; </span>_/eax: int <span class="Delimiter">{</span>
<span id="L61" class="LineNr">61 </span>  <span class="PreProc">var</span> self/<span class="muRegEsi">esi</span>: (addr <a href='float-stack.mu.html#L1'>float-stack</a>) <span class="Special">&lt;-</span> copy _self
<span id="L62" class="LineNr">62 </span>  <span class="PreProc">var</span> top-addr/eax: (addr int) <span class="Special">&lt;-</span> <a href='../131table.subx.html#L26'>get</a> self, <a href='../203stack.subx.html#L338'>top</a>
<span id="L63" class="LineNr">63 </span>  <span class="PreProc">return</span> *top-addr
<span id="L64" class="LineNr">64 </span><span class="Delimiter">}</span>
</pre>
</body>
</html>
<!-- vim: set foldmethod=manual : -->
